package com.mscit2020.sensorsexample;

import androidx.appcompat.app.AppCompatActivity;

import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.os.Bundle;
import android.widget.TextView;

public class MainActivity extends AppCompatActivity implements SensorEventListener {

    TextView xA, yA, zA, xG, yG, zG, xM, yM, zM, txtLight, txtPressure, txtHumidity;
    SensorManager sensorManager;
    Sensor sAccel, sLight, sHumid, sPressure, sGyro, sMagnet;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        xA = findViewById(R.id.xAcc);
        yA = findViewById(R.id.yAcc);
        zA = findViewById(R.id.zAcc);

        xG = findViewById(R.id.xG);
        yG = findViewById(R.id.yG);
        zG = findViewById(R.id.zG);

        xM = findViewById(R.id.xM);
        yM = findViewById(R.id.yM);
        zM = findViewById(R.id.zM);

        txtHumidity = findViewById(R.id.t_HS);
        txtLight = findViewById(R.id.t_LS);
        txtPressure = findViewById(R.id.t_PS);

        sensorManager = (SensorManager) getSystemService(SENSOR_SERVICE);

        sAccel = sensorManager.getDefaultSensor(Sensor.TYPE_ACCELEROMETER);
        if (sAccel != null) {
            sensorManager.registerListener(this, sAccel, SensorManager.SENSOR_DELAY_NORMAL);
        } else {
            xA.setText("Accelerometer is not supported");
        }
        sGyro = sensorManager.getDefaultSensor(Sensor.TYPE_GYROSCOPE);
        if (sGyro != null) {
            sensorManager.registerListener(this, sGyro, SensorManager.SENSOR_DELAY_NORMAL);
        } else {
            xG.setText("Gyro Sensor is not supported");
        }
        sMagnet = sensorManager.getDefaultSensor(Sensor.TYPE_MAGNETIC_FIELD);
        if (sMagnet != null) {
            sensorManager.registerListener(this, sMagnet, SensorManager.SENSOR_DELAY_NORMAL);
        } else {
            xM.setText("Accelerometer is not supported");
        }
        sLight = sensorManager.getDefaultSensor(Sensor.TYPE_LIGHT);
        if (sLight != null) {
            sensorManager.registerListener(this, sLight, SensorManager.SENSOR_DELAY_NORMAL);
        } else {
            txtLight.setText("Light is not supported");
        }
        sPressure = sensorManager.getDefaultSensor(Sensor.TYPE_PRESSURE);
        if (sPressure != null) {
            sensorManager.registerListener(this, sPressure, SensorManager.SENSOR_DELAY_NORMAL);
        } else {
            txtPressure.setText("Pressure Sensor is not supported");
        }
        sHumid = sensorManager.getDefaultSensor(Sensor.TYPE_AMBIENT_TEMPERATURE);
        if (sHumid != null) {
            sensorManager.registerListener(this, sHumid, SensorManager.SENSOR_DELAY_NORMAL);
        } else {
            txtHumidity.setText("Humidity Sensor is not supported");
        }


    }

    @Override
    public void onSensorChanged(SensorEvent event) {
        Sensor sensor = event.sensor;
        if (sensor.getType() == Sensor.TYPE_ACCELEROMETER) {
            xA.setText("X: " + event.values[0]);
            yA.setText("Y: " + event.values[1]);
            zA.setText("Z: " + event.values[2]);
        } else if (sensor.getType() == Sensor.TYPE_MAGNETIC_FIELD) {
            xM.setText("X: " + event.values[0]);
            yM.setText("Y: " + event.values[1]);
            zM.setText("Z: " + event.values[2]);
        } else if (sensor.getType() == Sensor.TYPE_GYROSCOPE) {
            xG.setText("X: " + event.values[0]);
            yG.setText("Y: " + event.values[1]);
            zG.setText("Z: " + event.values[2]);
        } else if (sensor.getType() == Sensor.TYPE_LIGHT) {
            txtLight.setText("Light: " + event.values[0]);

        } else if (sensor.getType() == Sensor.TYPE_AMBIENT_TEMPERATURE) {
            txtHumidity.setText("Temp: " + event.values[0]);

        } else if (sensor.getType() == Sensor.TYPE_PRESSURE) {
            txtPressure.setText("X: " + event.values[0]);

        }
    }

    @Override
    public void onAccuracyChanged(Sensor sensor, int accuracy) {

    }
}